package	jp.co.sds_corp.fixconnect.logger;

import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Date;

import jp.co.sds_corp.fixconnect.message.FIXMessage;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.log.CmnLogger;

public class FileLogger extends AbstractMessageLogger
{
	static CmnLogger logger = CmnLogger.getInstance();
	String	dir;
	String	filename;
	SimpleDateFormat sdf;

	public void init( IConfiguration config ) throws Exception {
		super.init( config );
		IConfiguration attr = config.getAttributes();
		dir = attr.get( "dir", null );
		filename = attr.get( "filename", null );
		sdf = new SimpleDateFormat( "yyyyMMddHHmmssSSS" );
	}

	public void log( Direction direction, FIXMessage msg ) throws Exception {
		String time = sdf.format( new Date() );
		String fnam = dir + File.separator + filename + "." + time;
		logger.debug( this, direction + " file: " + fnam );

		File file = new File( fnam );
		FileOutputStream fos = new FileOutputStream( file );
		fos.write( msg.getBuffer() );
		if ( isDump()) {
			PrintWriter pw = new PrintWriter( fos );
			pw.print( "\n" + dump( msg ));
			pw.flush();
			pw.close();
		}
		fos.flush();
		fos.close();
	}

}
