package	jp.co.sds_corp.fixconnect.message;

import jp.co.sds_corp.fixconnect.FIXException;

public class FIXParseException extends FIXException
{
	private static final long serialVersionUID = 1L;
	SessionRejectReason rejectReason;

	public FIXParseException( String message ) {
		super( message );
	}

	public FIXParseException( String message, SessionRejectReason rejectReason )
	{
		super( message );
		this.rejectReason = rejectReason;
	}

	public FIXParseException( String message, Throwable cause,
			SessionRejectReason rejectReason )
	{
		super( message, cause );
		this.rejectReason = rejectReason;
	}

	public SessionRejectReason getRejectReason() {
		return rejectReason;
	}

	public String getMessage() {
		String ret = super.getMessage();
		if ( rejectReason != null ) {
			ret += " RejectReason=" + rejectReason;
		}
		return ret;
	}

}
