package	jp.co.sds_corp.fixconnect.message;

import java.io.ByteArrayOutputStream;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.List;
import java.util.Vector;

public class Node
{
	HashMap<Tag,String> mapTag = new HashMap<Tag,String>();
	Vector<Component>	vecComp = new Vector<Component>();

	public Node() {
	}

	public String getValue( Tag tag ) {
		return mapTag.get( tag );
	}
	public String putValue( Tag tag, String value ) {
		return mapTag.put( tag, value );
	}
	public String putValue( Field fld ) {
		return mapTag.put( fld.getTag(), fld.getValue() );
	}

	public Component addComponent( Field fld ) {
		Component comp = new Component( fld );
		vecComp.add( comp );
		return comp;
	}

	public void getBytes( ByteArrayOutputStream bos, TagDictionary dict )
	{
		PrintWriter pw = new PrintWriter( bos );
		List<Tag> list = dict.listTag();
		for ( int i = 0; i < list.size(); i++ ) {
			Tag tag = list.get( i );
			String value = mapTag.get( tag );
			if ( value == null ) {
				continue;
			}
			if ( tag.getTagId() == Tag.BeginString.getTagId() ||
				tag.getTagId() == Tag.BodyLength.getTagId())
			{
				continue;
			}
			pw.print( tag.getTagId() + "=" + value );
			pw.flush();
			bos.write( FIXMessage.SOH );
		}
/*
		// TAGの並び替えが必要
		Iterator<Tag> itr = mapTag.keySet().iterator();
		while ( itr.hasNext()) {
			Tag tag = itr.next();
			String value = mapTag.get( tag );
			pw.print( tag.getTagId() + "=" + value );
			pw.flush();
			bos.write( FIXMessage.SOH );
		}
*/

		for ( int i = 0; i < vecComp.size(); i++ ) {
			Component comp = vecComp.get( i );
			comp.getBytes( bos, dict );
		}
	}

	public String toString() {
		String ret = mapTag.toString();
		for ( int i = 0; i < vecComp.size(); i++ ) {
			Component comp = vecComp.get( i );
			ret += comp.toString();
		}
		return ret;
	}

}
