package	jp.co.sds_corp.fixconnect.message;


public class Tag
{
	// FIX header
	public static Tag BeginString = new Tag( 8, Position.HEADER, true );
	public static Tag BodyLength = new Tag( 9, Position.HEADER, true );
	public static Tag MsgType = new Tag( 35, Position.HEADER, true );
	public static Tag MsgSeqNum = new Tag( 34, Position.HEADER, true );
	public static Tag SendingTime = new Tag( 52, Position.HEADER, true );

	// FIX trailer
	public static Tag CheckSum = new Tag( 10, Position.TRAILER, true );

	public enum DataType {
		INT,
			Length, TagNum, SeqNum, NumInGroup, DayOfMonth,
		FLOAT,
			Qty, Price, PriceOffset, Amt, Percentage,
		CHAR,
			Boolean,
		STRING,
			MultipleCharValue, MultipleStringValue,
			Country, Currency, Exchange, MonthYear,
			UTCTimestamp, UTCTimeOnly, UTCDateOnly, LocalMktDate,
			TZTimeOnly, TZTimestamp,
			data, XMLData, Language,
		PATTERN,
			Tenor, Reserved100Plus, Reserved1000Plus, Reserved4000Plus
	}

	public enum Position {
		UNKNOWN, HEADER, BODY, TRAILER
	}

	public Tag() {
		this.position = Position.UNKNOWN;
	}

	public Tag( Integer tagId, Position position, boolean required ) {
		this.tagId = tagId;
		this.position = position;
		this.required = required;
	}

	public String toString() {
		String ret;
		ret = name + "(" + tagId + ")";
		return ret;
	}

	int	tagId;	// Tag ID
	String	name;	// タグ名
	Position	position;	// Tag位置
	boolean	required;	// 必須

	/**
	* Tag IDを設定します。
	* @param	var		設定するデータ
	*/
	public void setTagId( int var ) {
		this.tagId = var;
	}
	/**
	* Tag IDを取得します。
	* @return	Tag ID
	*/
	public int getTagId() {
		return tagId;
	}

	/**
	* タグ名を設定します。
	* @param	var		設定するデータ
	*/
	public void setName( String var ) {
		this.name = var;
	}
	/**
	* タグ名を取得します。
	* @return	タグ名
	*/
	public String getName() {
		return name;
	}

	/**
	* Tag位置を設定します。
	* @param	var		設定するデータ
	*/
	public void setPosition( Position var ) {
		this.position = var;
	}
	/**
	* Tag位置を取得します。
	* @return	Tag位置
	*/
	public Position getPosition() {
		return position;
	}

	/**
	* 必須を設定します。
	* @param	var		設定するデータ
	*/
	public void setRequired( boolean var ) {
		this.required = var;
	}
	/**
	* 必須を取得します。
	* @return	必須
	*/
	public boolean isRequired() {
		return required;
	}

}
